# Marijn's popout window functionality
# Allows arbitrary divs be popped out into their own window or popped back in again
# Use: 1) Create Popout object for each separate popup window
#      2) Pass pop_inout the id of element to be popped into a separate window
#      3) This will load popup.htm in a separate window that calls back for the data and css links in original page
#      4) Call pop_inout('id') again to put get the external window back in to your original :-)

# Originally devt location: \pop



#Closure to keep pending_popouts private as opposed to global
# Lets not use for now as this means Popout is not available either!! requires further pondering
#(function () {

var pending_popouts=[];
var current_popouts=[];

function Popout(){
	dbg("POPOUT","fns constructor Popout");
#	External interface	
	this.pop_inout=pop_inout;
	this.setCustomCb=setCustomCb;
	this.isPoppedOut=isPoppedOut;

# 	Implementation
	var win=null;
	var doc=null;
	var master_win=null;
	var master_doc=null;
	var custom_popin=new Function();
    var custom_popout=new Function();;

	init();

	function init(){		
		master_doc = doc = document;		
		master_win = win = window;		
	}

# 	Toggle popout window
	function pop_inout(el_id, options){	
		var old_doc, new_doc, old_win, new_win, el;
		var width, height;
#dbg("window.document==Dbg.doc : " + (window.document==Dbg.doc));
		if (doc!=master_doc){
#			Already popped out so pop it back in
			dbg("POPOUT","popping window back in");
						
			old_doc = doc;
			old_win = win;
			new_doc = master_doc;

			new_doc.getElementById(el_id).innerHTML = old_doc.getElementById("popout").innerHTML;
			doc = new_doc;
			win = this.master_win;

			new_doc.getElementById(el_id).className='';
			old_doc.already_popped=true;
			delete current_popouts[old_win];
			old_win.close();

            custom_popin(new_doc);
		}else{
			dbg("POPOUT","popping element out as window");

			old_doc = doc;
			el = old_doc.getElementById(el_id);
			width=el.offsetWidth;
			height=el.offsetHeight;
			el.className='poppedout';

			new_win = window.open("||www_base||ajax/modules/popout.htm","","left=100,right=100,width="+width+",height="+height+",dependent=1,hotkeys=0,menubar=0,personalbar=0,resizable=1,status=0,titlebar=0,toolbar=1,z-lock=1");
			if (new_win==null){
				alert("Ooops... was your request get blocked by a popup blocker?");
				el.className='';
				return;
			}
			pending_popouts[new_win]={obj:this, fn:doPopoutCompletion, "el_id":el_id};
			dbg("POPOUT","doPopoutCompletion ready for popout to call back");		
		}
	}

# 	Complete pending popout action					
	function doPopoutCompletion(new_win,el_id){				/* previously Dbg.doPopoutCb */
		dbg("POPOUT","received callback from popout window for content");
		var old_doc, new_doc, el;

		new_doc = new_win.document;
		old_doc = doc;

		el=old_doc.getElementById(el_id);
		new_doc.getElementById("popout").innerHTML = el.innerHTML;
		
		doc = new_doc;
		win = new_win;

        custom_popout(new_doc);
		
#		el.className='poppedout';
		current_popouts[new_win]={win:new_win};
		pending_popouts[new_win]=null;
	}

# Going the other way, allow consumers of this class to add custom fns too

#	Allow consumers of this class custom popup / popin actions
	function setCustomCb(fn_out, fn_in){
		custom_popin=fn_in;
		custom_popout=fn_out;
	}
# 	Current in / out state
	function isPoppedOut(id){	
		return doc!=master_doc;
	}

}

function closeAllPopouts(id){	
	for (var i in current_popouts){
		var term=current_popouts[i];
		if (typeof(term) == 'function') continue;	// for those nitwits that globally overrride the array object
		term.win._master_detached="true";
		term.win.close();
#		term.win.reconnect();
	}
}

window.onbeforeunload=closeAllPopouts;

#})(); // end the closure

# Originally devt location: ..\pop\popout.js
setTimeout(function(){dbg("module Popout source file loaded (delayed)");},1000); 
